<?php
function to_get_dict($delete_old = false) {
	$options = get_option('WAT_options');
	$dict_file = WAT_CACHE_DIR . '/share.dict';
	if( $delete_old ) {
		@unlink($dict_file);
	}
	if( is_file($dict_file) ) {
		if( current_time('timestamp') - $options['last_get_dict_time'] > 604800 ) {
			return $dict_file;
		}
	}
	if( count($options['share_history']) > 0 ) {
		$dict = wat_sand_api('getdict');
		if( $dict !== false ) {
			if( file_put_contents($dict_file, $dict) ) {
				$options['last_get_dict_time'] = current_time('timestamp');
				update_option('WAT_options', $options);
				return $dict_file;
			}
		}
	}
	return false;
}

function wat_sand_api($action, $file = '') {
	if( function_exists('curl_init') ) {
		$compress = 0;
		if( function_exists('gzuncompress') ) {
			$compress = 1;
		}
		$fields = array(
			'action' => $action,
			'compress' => $compress,
			'version' => get_option('WAT_version')
		);
		if( is_file($file) ) {
			switch($compress) {
				case 1:
					file_put_contents($file . '.gz', gzcompress(file_get_contents($file)));
					$file = $file . '.gz';
					break;
			}
			$fields['up_data'] = '@' . $file;
		}

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'http://tagdict.info/get_api.php');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt($ch, CURLOPT_COOKIE, '');
		curl_setopt($ch, CURLOPT_TIMEOUT, 15);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
		$body = @curl_exec($ch);
		$info = @curl_getinfo($ch);
		@curl_close($ch);
		$http = $info['http_code'];
		if( $http >= 200 && $http < 300 ) {
			switch($compress) {
				case 1:
					$body = gzuncompress(base64_decode($body));
					break;
			}
			if( $file != '' ) {
				@unlink($file);
			}
			return $body;
		}
	}
	return false;
}
?>