<?php
class WAT_admin_options {
	private $options;

	public function __construct() {
		$this->options = get_option('WAT_options');
		add_action('admin_menu', array(&$this, 'add_menu'));
	}

	public function add_menu() {
		add_menu_page('WP Auto Tag', __('WP Auto Tag', 'WAT'), 'manage_options', 'WAT_options', array(&$this, 'show_setting'));
		add_submenu_page('WAT_options', __('WP Auto Tag Options', 'WAT'), __('Options', 'WAT'), 'manage_options', 'WAT_options', array($this, 'show_setting'));
		add_submenu_page('WAT_options', __('WP Auto Tag Share', 'WAT'), __('share', 'WAT'), 'manage_options', 'WAT_share', array($this, 'show_share'));
		//add_submenu_page('WAT_options', __('WP Auto Tag test', 'WAT'), __('test', 'WAT'), 'manage_options', 'WAT_test', array($this, 'show_test'));
	}

	private function over_admin_header() {
		echo('<table width="95%"><tr><td>');
	}

	private function over_admin_footer() {
		$version = get_option('WAT_version');
		echo('</td><td width="120" valign="top">');
		echo('<h3>感謝您的使用！</h3>');
		echo('<p>本外掛使用的字典檔是源自於網站：<br /><a href="http://tagdict.info/">TagDict</a><br /><br />您分享的字典檔也會合併進該網站中使用，並進一步的分享給所有使用本外掛的使用者！</p>');
		echo('<p>如有任何的問題或建議，請與 <a href="mailto:service@tagdict.info">我們聯繫</a></p>');
		echo('<p>' . __('Version:', 'WAT') . $version . '</p>');
		echo('</td></tr></table>');
	}

	public function show_setting() {
		$this->over_admin_header();
		if( !empty($_POST['submit']) ) {
			$this->save_settings();
		}

		echo('<div class="wrap"><h2>' . __('WP Auto Tag Options', 'WAT') . '</h2><form method="post" action="">');

		$f_checked = checked($this->options['analytic_ngram_type'], 'f', false);
		$r_checked = checked($this->options['analytic_ngram_type'], 'r', false);
		$max_words = $this->options['analytic_max_words'];
		$max_tags = $this->options['analytic_max_tags'];
		$tag_max_len = 0;
		$tags = get_terms('post_tag');
		foreach( $tags as $key => $tag ) {
			if( !preg_match('/^[ 0-9a-z_\.\^-]*$/i', $tag->name) ) {
				$tag_max_len = max(mb_strlen($tag->name), $tag_max_len);
			}
		}
		echo('<h3>' . __('WP Auto Tag setting', 'WAT') . '</h3>');
		echo('<table class="form-table">');
		echo('<tr valign="top"><th>' . __('analytic direction', 'WAT') . '</th><td>');
			echo('<label><input type="radio" value="f" name="analytic_ngram_type" ' . $f_checked . ' /> ' . __('Forward (from left to right)', 'WAT') . '</label> &nbsp; ');
			echo('<label><input type="radio" value="r" name="analytic_ngram_type" ' . $r_checked . ' /> ' . __('Reverse (from right to left)', 'WAT') . '</label><br />');
		echo('</td></tr>');
		echo('<tr valign="top"><th>' . __('Maximum number of words', 'WAT') . '</th><td>');
			echo('<input type="text" value="' . $max_words . '" name="analytic_max_words" id="analytic_max_words" size="3" /> ' . __('Words', 'WAT'));
		echo('</td></tr>');
		echo('<tr valign="top"><th>' . __('Recommended tag number', 'WAT') . '</th><td>');
			echo('<input type="text" value="' . $max_tags . '" name="analytic_max_tags" id="analytic_max_tags" size="3" />');
		echo('</td></tr>');
		echo('</table>');

		$autotag_link_1 = checked($this->options['autotag_link'], '1', false);
		$autotag_link_0 = checked($this->options['autotag_link'], '0', false);
		$autotag_link_nofollow_1 = checked($this->options['autotag_link_nofollow'], '1', false);
		$autotag_link_nofollow_0 = checked($this->options['autotag_link_nofollow'], '0', false);
		$autotag_link_maxtimes = $this->options['autotag_link_maxtimes'];
		$autotag_link_addin = array(
			'home' => checked($this->options['autotag_link_addin']['home'], true, false),
			'single' => checked($this->options['autotag_link_addin']['single'], true, false),
			'archive' => checked($this->options['autotag_link_addin']['archive'], true, false),
			'search' => checked($this->options['autotag_link_addin']['search'], true, false)
		);
		echo('<h3>' . __('Add Tag Link in Content', 'WAT') . '</h3>');
		echo('<table class="form-table">');
		echo('<tr valign="top"><th>' . __('Add link enabled?', 'WAT') . '</th><td>');
			echo('<label><input type="radio" value="1" name="autotag_link" ' . $autotag_link_1 . ' /> ' . __('Enabled', 'WAT') . ' </label> &nbsp;');
			echo('<label><input type="radio" value="0" name="autotag_link" ' . $autotag_link_0 . ' /> ' . __('Disabled', 'WAT') . ' </label><br />');
			_e('Only work when using "the_content();" in your theme.', 'WAT');
		echo('</td></tr>');
		echo('<tr valign="top"><th>' . __('Add in page?', 'WAT') . '</th><td>');
			echo(__('At page', 'WAT') . ' 【 ');
			foreach( $autotag_link_addin as $key => $value ) {
				echo('<input type="checkbox" value="' . $key . '" name="autotag_link_addin[]" ' . $value . ' /> ' . __($key, 'WAT') . ' &nbsp');
			}
			echo('】');
		echo('</td></tr>');
		echo('<tr valign="top"><th>' . __('Max times of the same tag?', 'WAT') . '</th><td>');
			echo('<input type="text" value="' . $autotag_link_maxtimes . '" name="autotag_link_maxtimes" id="autotag_link_maxtimes" size="3" />' . __('(0 is without limit)', 'WAT'));
		echo('</td></tr>');
		echo('<tr valign="top"><th>' . __('Add nofollow?', 'WAT') . '</th><td>');
			echo('<label><input type="radio" value="1" name="autotag_link_nofollow" ' . $autotag_link_nofollow_1 . ' /> ' . __('Enabled', 'WAT') . ' </label> &nbsp;');
			echo('<label><input type="radio" value="0" name="autotag_link_nofollow" $autotag_link_nofollow_0 /> ' . __('Disabled', 'WAT') . ' </label>');
		echo('</td></tr>');
		echo('</table>');

		$related_post_1 = checked($this->options['related_post'], '1', false);
		$related_post_0 = checked($this->options['related_post'], '0', false);
		$related_post_add_content_1 = checked($this->options['related_post_add_content'], '1', false);
		$related_post_add_content_0 = checked($this->options['related_post_add_content'], '0', false);
		$related_post_add_post_type = array();
		$post_types = get_post_types(array('public' => true), 'objects');
		foreach( $post_types as $post_types_name => $post_type ) {
			if( isset($this->options['related_post_add_post_type'][$post_types_name]) ) {
				$show_stats = $this->options['related_post_add_post_type'][$post_types_name];
			} else {
				$show_stats = true;
			}
			$related_post_add_post_type[$post_types_name] = array(
				'name' => $post_type->labels->name,
				'checked' => checked($show_stats, true, false)
			);
		}
		$related_post_aside_tag_1 = checked($this->options['related_post_aside_tag'], '1', false);
		$related_post_aside_tag_0 = checked($this->options['related_post_aside_tag'], '0', false);
		$related_post_title = $this->options['related_post_title'];
		$related_post_count = $this->options['related_post_count'];
		$related_post_img_1 = checked($this->options['related_post_img'], '1', false);
		$related_post_img_0 = checked($this->options['related_post_img'], '0', false);
		echo('<h3>' . __('Related Posts', 'WAT') . '</h3>');
		echo('<table class="form-table">');
		echo('<tr valign="top"><th>' . __('Related posts enabled?', 'WAT') . '</th><td>');
			echo('<label><input type="radio" value="1" name="related_post" ' . $related_post_1 . ' /> ' . __('Enabled', 'WAT') . ' </label> &nbsp;');
			echo('<label><input type="radio" value="0" name="related_post" ' . $related_post_0 . ' /> ' . __('Disabled', 'WAT') . ' </label>');
		echo('</td></tr>');
		echo('<tr valign="top"><th>' . __('Auto add in content', 'WAT') . '</th><td>');
			echo('<label><input type="radio" value="1" name="related_post_add_content" ' . $related_post_add_content_1 . ' /> ' . __('Enabled', 'WAT') . ' </label> &nbsp;');
			echo('<label><input type="radio" value="0" name="related_post_add_content" ' . $related_post_add_content_0 . ' /> ' . __('Disabled', 'WAT') . ' </label><br />');
			_e('When using "the_content();" in your theme, add the related posts list at the end of content.', 'WAT');
			echo('<table class="form-table">');
			echo('<tr valign="top"><th>' . __('Add in page?', 'WAT') . '</th><td>');
				echo(__('At post type ', 'WAT') . ' 【 ');
				foreach( $related_post_add_post_type as $post_types_name => $show ) {
					echo('<input type="checkbox" value="' . $post_types_name . '" name="related_post_add_post_type[]" ' . $show['checked'] . ' /> ' . $show['name'] . ' &nbsp');
				}
				echo('】');
			echo('</td></tr>');
			echo('<tr valign="top"><th>' . __('HTML tag', 'WAT') .'</th><td>');
				echo('<label><input type="radio" value="1" name="related_post_aside_tag" ' . $related_post_aside_tag_1 . ' /> aside </label> &nbsp;');
				echo('<label><input type="radio" value="0" name="related_post_aside_tag" ' . $related_post_aside_tag_0 . ' /> div </label>');
			echo('</td></tr>');
			echo('<tr valign="top"><th>' . __('Title:', 'WAT') . '</th><td>');
				echo('<input type="text" value="' . $related_post_title . '" name="related_post_title" id="related_post_title" />');
			echo('</td></tr>');
			echo('<tr valign="top"><th>' . __('Number of posts to show:', 'WAT') . '</th><td>');
				echo('<input type="text" value="' . $related_post_count . '" name="related_post_count" id="related_post_count" size="3" />');
			echo('</td></tr>');
			echo('<tr valign="top"><th>' . __('Show featured image', 'WAT') . '</th><td>');
				echo('<label><input type="radio" value="1" name="related_post_img" ' . $related_post_img_1 . ' /> ' . __('Enabled', 'WAT') . ' </label> &nbsp;');
				echo('<label><input type="radio" value="0" name="related_post_img" ' . $related_post_img_0 . ' /> ' . __('Disabled', 'WAT') . ' </label>');
			echo('</td></tr>');
			echo('</table>');
		echo('</td></tr>');
		echo('</table>');
		echo('<input type="submit" name="submit" class="button-primary" value="' . __('Update Options', 'WAT') . '" />');
		$this->over_admin_footer();
	}

	private function save_settings() {
		$this->options['analytic_ngram_type'] = ($_POST['analytic_ngram_type'] == 'f') ? 'f' : 'r';
		$this->options['analytic_max_words'] = intval($_POST['analytic_max_words']);
		$this->options['analytic_max_tags'] = intval($_POST['analytic_max_tags']);

		$this->options['autotag_link'] = intval((bool)$_POST['autotag_link']);
		$this->options['autotag_link_addin'] = array(
			'home' => false,
			'single' => false,
			'archive' => false,
			'search' => false
		);
		if( isset($_POST['autotag_link_addin']) && is_array($_POST['autotag_link_addin']) && count($_POST['autotag_link_addin']) > 0 ) {
			foreach( $_POST['autotag_link_addin'] as $value ) {
				switch($value) {
					case 'home':
						$this->options['autotag_link_addin']['home'] = true;
						break;
					case 'single':
						$this->options['autotag_link_addin']['single'] = true;
						break;
					case 'archive':
						$this->options['autotag_link_addin']['archive'] = true;
						break;
					case 'search':
						$this->options['autotag_link_addin']['search'] = true;
						break;
				}
			}
		}
		$this->options['autotag_link_maxtimes'] = intval($_POST['autotag_link_maxtimes']);
		$this->options['autotag_link_nofollow'] = intval((bool)$_POST['autotag_link_nofollow']);

		$this->options['related_post'] = intval((bool)$_POST['related_post']);
		$this->options['related_post_add_content'] = intval((bool)$_POST['related_post_add_content']);
		if( isset($_POST['related_post_add_post_type']) && is_array($_POST['related_post_add_post_type']) && count($_POST['related_post_add_post_type']) > 0 ) {
			$post_types = get_post_types(array('public' => true));
			foreach( $_POST['related_post_add_post_type'] as $post_type_name ) {
				if( isset($post_types[$post_type_name]) ) {
					$this->options['related_post_add_post_type'][$post_type_name] = true;
				} else {
					$this->options['related_post_add_post_type'][$post_type_name] = false;
				}
			}
		}
		$this->options['related_post_aside_tag'] = intval((bool)$_POST['related_post_aside_tag']);
		$this->options['related_post_title'] = trim($_POST['related_post_title']);
		$this->options['related_post_count'] = intval($_POST['related_post_count']);
		$this->options['related_post_img'] = intval((bool)$_POST['related_post_img']);

		update_option('WAT_options', $this->options);

		echo('<div id="message" class="updated"><p><span style="color:green">' . __('Succeed update options!', 'WAT') . '</span></p></div>');
	}

	public function show_share() {
		$this->over_admin_header();
		if( !empty($_POST['submit']) ) {
			$this->do_share();
		}
		if( !empty($_POST['clear_history']) ) {
			$this->do_clear_history();
		}

		echo('<div class="wrap"><h2>' . __('WP Auto Tag Share', 'WAT') . '</h2>');
		echo <<<END
<p>某天的夜晚忽然想到自動替文章加入標籤的功能。可惜的是沒有找到可以良善運作於中文的自動標籤外。因而花了我一些時間做出這一個外掛。</p>
<p>中文的自動斷詞是一項高深的問題，甚至有博士生的論文就是專研於這一個領域。<br />主要的難題之一在於，中文的詞與詞中間沒有明確的分割，所以在一連串的單字當中要組合出符合作者想法的詞是問題的關鍵。</p>
<p>由於合法的詞庫取得不易，因此本外掛主要採用 <a href="http://en.wikipedia.org/wiki/N-gram" target="_blank">N gram</a> 的方法，並輔以網站現有的標籤進行分詞，最後再計算各詞權重計算取得結果。</p>
<p>但這樣只有獨樂樂啊！網路的世界就是要分享、要眾樂樂才會好玩才會精采的。<br />因此如果你願意的話，分享你的標籤資料給其他也有使用這一外掛的人，讓自動化的功能更加有效與精準！</p>
<p>分享你的標籤資料，並不會帶給額外的流量負擔。</p>
END;
		if( count($this->options['share_history']) > 0 ) {
			$date_format = get_option('links_updated_date_format');
			echo('<h3>' . __('Share history', 'WAT') . '</h3>');
			echo('<table class="widefat">');
			echo('<thead><tr><th>' . __('Share time', 'WAT') . '</th><th>' . __('Tag number', 'WAT') . '</th><th>' . __('New word number', 'WAT') . '</th></tr></thead>');
			$i = 0;
			foreach( $this->options['share_history'] as $share ) {
				$last_share_time = date($date_format, $share['time']);
				$total_word = $share['new_word'] + $share['old_word'];
				echo('<tr><td>' . $last_share_time . '</td><td>' . $total_word . '</td><td>' . $share['new_word'] . '</td></tr>');
				$i++;
				if( $i > 10 ) {
					break;
				}
			}
			echo('<tfoot><tr><td colspan="3"><form method="post" action=""><input type="submit" name="clear_history" class="button-primary" value="' . __('Clear old share history log', 'WAT') . '" /></form></td></tr></tfoot></table>');
		}
		echo('<form method="post" action=""><p><input type="submit" name="submit" class="button-primary" value="' . __('Share my tag data', 'WAT') . '" /></p></form>');
		$this->over_admin_footer();
	}

	private function do_share() {
		$upload = false;
		$dict = get_locale() . "\n";
		$dict .= $this->options['related_post'] . "\n";
		$dict .= get_bloginfo('blogname') . "\n";
		$dict .= get_bloginfo('wpurl') . "\n";
		$tags = get_terms('post_tag');
		foreach( $tags as $key => $tag ) {
			$dict .= sprintf('%s,%s,%s' . "\n", $tag->name, $tag->count, get_tag_link($tag));
		}
		$file = WAT_CACHE_DIR . '/share_dict.txt';
		file_put_contents($file, $dict);
		if( is_file($file) ) {
			$upload_result = wat_sand_api('uploaddict', $file);
			if( $upload_result !== false ) {
				$result = explode(',', $upload_result);
				if( count($result) == 2 ) {
					$upload = true;
					array_unshift($this->options['share_history'], array(
						'time' => current_time('timestamp'),
						'new_word' => intval($result[0]),
						'old_word' => intval($result[1])
					));
					update_option('WAT_options', $this->options);
				}
			}
			@unlink($file);
		}
		if( $upload ) {
			to_get_dict(true);
			echo('<div id="message" class="updated"><p><span style="color:green">' . __('Succeed share tag data!', 'WAT') . '</span></p></div>');
		} else {
			echo('<div id="message" class="error"><p><span style="color:rad">' . __('failed share tag data!', 'WAT') . '</span></p></div>');
		}
	}

	private function do_clear_history() {
		$history = array_shift($this->options['share_history']);
		$this->options['share_history'] = array();
		$this->options['share_history'][] = $history;
		update_option('WAT_options', $this->options);
	}

	public function show_test() {
		$this->over_admin_header();
		$content = '';
		if( !empty($_POST['submit']) ) {
			$content = $this->do_test();
		}

		echo('<div class="wrap"><h2>' . __('WP Auto Tag test', 'WAT') . '</h2>');
		echo <<<END
<form method="post" action=""><table class="form-table">
<tr><th><label for="test_content">測試內容</label></th><td><textarea name="test_content" id="test_content" rows="10" cols="100">$content</textarea></td></tr>
<tfoot><tr><td colspan="2"><input type="submit" name="submit" class="button-primary" value="分析生成文章的標籤" /></td></tr></tfoot>
</table></form>
END;
		$this->over_admin_footer();
	}

	private function do_test() {
		global $WAT_item;

		$content = trim($_POST['test_content']);
		$mtime = explode(' ', microtime());
		$timestart = $mtime[1] + $mtime[0];
		$memstart = sprintf('%.3f', memory_get_peak_usage() / 1024 / 1024);
		$autotags = $WAT_item->make_tags('', $content);
		$mtime = explode(' ', microtime());
		$timeend = $mtime[1] + $mtime[0];
		$timetotal = sprintf('%.6f', $timeend - $timestart);
		$memend = sprintf('%.3f', memory_get_peak_usage() / 1024 / 1024);
		$addmem = $memend - $memstart;
		$result = implode(', ', $autotags);
		echo <<<END
<div id="message" class="updated"><p>
	<span style="color:green">測試分析完成！</span><br />分析的結果為：$result<br />花費 $timetotal 秒記憶體使用 $memend MB(增加 $addmem MB)
</p></div>
END;
		return $content;
	}
}

new WAT_admin_options();
?>